--- include/class.notification.php	2009-01-12 23:15:12.082081730 +0200
+++ /usr/share/eventum/include/class.notification.php	2009-02-05 02:15:18.637536613 +0200
@@ -36,20 +36,6 @@
  * @author João Prado Maia <jpm@mysql.com>
  */
 
-require_once(APP_INC_PATH . "class.error_handler.php");
-require_once(APP_INC_PATH . "class.misc.php");
-require_once(APP_INC_PATH . "class.setup.php");
-require_once(APP_INC_PATH . "class.auth.php");
-require_once(APP_INC_PATH . "class.user.php");
-require_once(APP_INC_PATH . "class.prefs.php");
-require_once(APP_INC_PATH . "class.custom_field.php");
-require_once(APP_INC_PATH . "class.template.php");
-require_once(APP_INC_PATH . "class.mail.php");
-require_once(APP_INC_PATH . "class.date.php");
-require_once(APP_INC_PATH . "class.project.php");
-require_once(APP_INC_PATH . "class.history.php");
-require_once(APP_INC_PATH . "class.issue.php");
-require_once(APP_INC_PATH . "class.priority.php");
 
 class Notification
 {
@@ -64,7 +50,7 @@
      */
     function isSubscribedToEmails($issue_id, $email)
     {
-        $email = strtolower(Mail_API::getEmailAddress($email));
+        $email = strtolower(Mail_Helper::getEmailAddress($email));
         if ($email == '@') {
             // broken address, don't send the email...
             return true;
@@ -113,7 +99,7 @@
         }
         $stmt .= "
                     sub_iss_id=" . Misc::escapeInteger($issue_id);
-        $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+        $res = Db_Helper::getInstance()->getCol($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -152,11 +138,11 @@
 
             // if no project name, use eventum wide sender name
             if (empty($info['sender_name'])) {
-                $setup_sender_info = Mail_API::getAddressInfo($setup['smtp']['from']);
+                $setup_sender_info = Mail_Helper::getAddressInfo($setup['smtp']['from']);
                 $info['sender_name'] = $setup_sender_info['sender_name'];
             }
         } else {
-            $info = Mail_API::getAddressInfo($sender);
+            $info = Mail_Helper::getAddressInfo($sender);
         }
         // allow flags even without routing enabled
         if (!empty($setup[$routing]['recipient_type_flag'])) {
@@ -200,7 +186,7 @@
                 $info['sender_name'] = '"' . $info['sender_name'] . ' ' . trim($flag) . '"';
             }
         }
-        $from = Mail_API::getFormattedName($info['sender_name'], $from_email);
+        $from = Mail_Helper::getFormattedName($info['sender_name'], $from_email);
 
         return MIME_Helper::encodeAddress(trim($from));
     }
@@ -236,8 +222,8 @@
     function isIssueRoutingSender($issue_id, $sender)
     {
         $check = Notification::getFixedFromHeader($issue_id, $sender, 'issue');
-        $check_email = strtolower(Mail_API::getEmailAddress($check));
-        $sender_email = strtolower(Mail_API::getEmailAddress($sender));
+        $check_email = strtolower(Mail_Helper::getEmailAddress($check));
+        $sender_email = strtolower(Mail_Helper::getEmailAddress($sender));
         if ($check_email == $sender_email) {
             return true;
         } else {
@@ -265,7 +251,7 @@
 
         $full_message = $message['full_email'];
         $sender = $message['from'];
-        $sender_email = strtolower(Mail_API::getEmailAddress($sender));
+        $sender_email = strtolower(Mail_Helper::getEmailAddress($sender));
         $structure = Mime_Helper::decode($full_message, true);
 
         // get ID of whoever is sending this.
@@ -310,7 +296,7 @@
             if (!empty($email)) {
                 // don't send the email to the same person who sent it
                 if ((($sender_usr_id != false) && (!empty($users[$i]["sub_usr_id"])) && ($sender_usr_id == $users[$i]["sub_usr_id"])) ||
-                        (strtolower(Mail_API::getEmailAddress($email)) == $sender_email)) {
+                        (strtolower(Mail_Helper::getEmailAddress($email)) == $sender_email)) {
                     continue;
                 }
                 $emails[] = $email;
@@ -328,7 +314,7 @@
         list($_headers, $body) = Mime_Helper::splitBodyHeader($full_message);
         $header_names = Mime_Helper::getHeaderNames($_headers);
 
-        $current_headers = Mail_API::stripHeaders($message['headers']);
+        $current_headers = Mail_Helper::stripHeaders($message['headers']);
         $headers = array();
         // build the headers array required by the smtp library
         foreach ($current_headers as $header_name => $value) {
@@ -342,7 +328,7 @@
             }
         }
 
-        $headers["Subject"] = Mail_API::formatSubject($issue_id, $headers['Subject']);
+        $headers["Subject"] = Mail_Helper::formatSubject($issue_id, $headers['Subject']);
 
         if (empty($type)) {
             if (($sender_usr_id != false) && (User::getRoleByUser($sender_usr_id, Issue::getProjectID($issue_id)) == User::getRoleID("Customer"))) {
@@ -352,11 +338,10 @@
             }
         }
 
-        @require_once(APP_PEAR_PATH . 'Mail/mime.php');
         foreach ($emails as $to) {
-            $recipient_usr_id = User::getUserIDByEmail(Mail_API::getEmailAddress($to));
+            $recipient_usr_id = User::getUserIDByEmail(Mail_Helper::getEmailAddress($to));
             // add the warning message about replies being blocked or not
-            $fixed_body = Mail_API::addWarningMessage($issue_id, $to, $body, $headers);
+            $fixed_body = Mail_Helper::addWarningMessage($issue_id, $to, $body, $headers);
             $headers['To'] = Mime_Helper::encodeAddress($to);
 
             Mail_Queue::add($to, $headers, $fixed_body, 1, $issue_id, $type, $sender_usr_id, $sup_id);
@@ -415,7 +400,7 @@
                     iss_id=" . Misc::escapeInteger($issue_id) . " AND
                     iss_prj_id=prj_id AND
                     iss_usr_id=usr_id";
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getRow($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -458,7 +443,7 @@
                  WHERE
                     not_id=" . Misc::escapeInteger($note_id) . " AND
                     not_usr_id=usr_id";
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getRow($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -504,7 +489,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "support_email
                  WHERE
                     sup_id IN ($items)";
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -543,7 +528,7 @@
                     iat_usr_id=usr_id AND
                     iat_iss_id=" . Misc::escapeInteger($issue_id) . " AND
                     iat_id=" . Misc::escapeInteger($attachment_id);
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getRow($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -590,7 +575,7 @@
                         sub_id=sbt_sub_id AND
                         sbt_type='" . Misc::escapeString($type) . "'";
         }
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return array();
@@ -807,11 +792,11 @@
                             " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "issue
                          WHERE
                             iss_id=" . Misc::escapeInteger($issue_id);
-                $customer_contact_id = $GLOBALS["db_api"]->dbh->getOne($stmt);
+                $customer_contact_id = Db_Helper::getInstance()->getOne($stmt);
                 if (!empty($customer_contact_id)) {
                     list($contact_email,,) = Customer::getContactLoginDetails($prj_id, $customer_contact_id);
                     for ($i = 0; $i < count($emails); $i++) {
-                        $email = Mail_API::getEmailAddress($emails[$i]);
+                        $email = Mail_Helper::getEmailAddress($emails[$i]);
                         if ($email == $contact_email) {
                             unset($emails[$i]);
                             $emails = array_values($emails);
@@ -847,7 +832,7 @@
                     } else {
                         $headers['In-Reply-To'] = Issue::getRootMessageID($issue_id);
                     }
-                    $headers['References'] = Mail_API::fold(join(' ', Mail_API::getReferences($issue_id, @$data['note']['reference_msg_id'], 'note')));
+                    $headers['References'] = Mail_Helper::fold(join(' ', Mail_Helper::getReferences($issue_id, @$data['note']['reference_msg_id'], 'note')));
                     $subject = 'Note';
                     break;
                 case 'emails':
@@ -907,7 +892,7 @@
         global $_EVENTUM_LAST_NOTIFIED_LIST;
 
         // open text template
-        $tpl = new Template_API;
+        $tpl = new Template_Helper();
         $tpl->setTemplate('notifications/' . $type . '.tpl.text');
         $tpl->bulkAssign(array(
             "app_title"    => Misc::getToolCaption(),
@@ -918,12 +903,12 @@
         $setup = Setup::load();
         $final_type = $type;
         $sender_usr_id = false;
-        $threading_headers = Mail_API::getBaseThreadingHeaders($issue_id);
+        $threading_headers = Mail_Helper::getBaseThreadingHeaders($issue_id);
         $emails = array_unique($emails);
         for ($i = 0; $i < count($emails); $i++) {
 
             $can_access = true;
-            $recipient_usr_id = User::getUserIDByEmail(Mail_API::getEmailAddress($emails[$i]));
+            $recipient_usr_id = User::getUserIDByEmail(Mail_Helper::getEmailAddress($emails[$i]));
             if (!empty($recipient_usr_id)) {
                 if (!Issue::canAccess($issue_id, $recipient_usr_id)) {
                     $can_access = false;
@@ -954,7 +939,7 @@
             }
 
             // send email (use PEAR's classes)
-            $mail = new Mail_API;
+            $mail = new Mail_Helper;
             $mail->setTextBody($tpl->getTemplateContents());
             if ($headers != false) {
                 $mail->setHeaders($headers);
@@ -974,7 +959,7 @@
                 } else {
                     $sender = User::getFromHeader($data["note"]["not_usr_id"]);
                 }
-                $sender_usr_id = User::getUserIDByEmail(Mail_API::getEmailAddress($sender));
+                $sender_usr_id = User::getUserIDByEmail(Mail_Helper::getEmailAddress($sender));
                 if (empty($sender_usr_id)) {
                     $sender_usr_id = false;
                 }
@@ -1046,11 +1031,11 @@
             $stmt .= " AND
                     usr_id NOT IN (" . join(', ', $exclude_list) . ")";
         }
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         $emails = array();
         for ($i = 0; $i < count($res); $i++) {
             @$res[$i]['usr_preferences'] = unserialize($res[$i]['usr_preferences']);
-            $subscriber = Mail_API::getFormattedName($res[$i]['usr_full_name'], $res[$i]['usr_email']);
+            $subscriber = Mail_Helper::getFormattedName($res[$i]['usr_full_name'], $res[$i]['usr_email']);
             // don't send these emails to customers
             if (($res[$i]['pru_role'] == User::getRoleID('Customer')) || (!empty($res[$i]['usr_customer_id']))
                     || (!empty($res[$i]['usr_customer_contact_id']))) {
@@ -1076,10 +1061,10 @@
                     isu_iss_id=$issue_id AND
                     usr_id=isu_usr_id AND
                     usr_status = 'active'";
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         for ($i = 0; $i < count($res); $i++) {
             @$res[$i]['usr_preferences'] = unserialize($res[$i]['usr_preferences']);
-            $subscriber = Mail_API::getFormattedName($res[$i]['usr_full_name'], $res[$i]['usr_email']);
+            $subscriber = Mail_Helper::getFormattedName($res[$i]['usr_full_name'], $res[$i]['usr_email']);
 
             if ((!empty($res[$i]['usr_preferences']['receive_assigned_emails'][$prj_id])) &&
             (@$res[$i]['usr_preferences']['receive_assigned_emails'][$prj_id]) && (!in_array($subscriber, $emails))) {
@@ -1148,26 +1133,26 @@
                 $recipient = $sender;
                 $is_message_sender = true;
             }
-            $recipient_usr_id = User::getUserIDByEmail(Mail_API::getEmailAddress($recipient));
+            $recipient_usr_id = User::getUserIDByEmail(Mail_Helper::getEmailAddress($recipient));
 
-            if (!Workflow::shouldEmailAddress($prj_id, Mail_API::getEmailAddress($recipient), $issue_id, 'auto_created')) {
+            if (!Workflow::shouldEmailAddress($prj_id, Mail_Helper::getEmailAddress($recipient), $issue_id, 'auto_created')) {
                 return;
             }
             $data = Issue::getDetails($issue_id);
 
             // open text template
-            $tpl = new Template_API;
+            $tpl = new Template_Helper();
             $tpl->setTemplate('notifications/new_auto_created_issue.tpl.text');
             $tpl->bulkAssign(array(
                 "app_title"   => Misc::getToolCaption(),
                 "data"        => $data,
-                "sender_name" => Mail_API::getName($sender),
-                'recipient_name'    => Mail_API::getName($recipient),
+                "sender_name" => Mail_Helper::getName($sender),
+                'recipient_name'    => Mail_Helper::getName($recipient),
                 'is_message_sender' =>  $is_message_sender
             ));
 
             // figure out if sender has a real account or not
-            $sender_usr_id = User::getUserIDByEmail(Mail_API::getEmailAddress($sender));
+            $sender_usr_id = User::getUserIDByEmail(Mail_Helper::getEmailAddress($sender));
             if ((!empty($sender_usr_id)) && (Issue::canAccess($issue_id, $sender_usr_id))) {
                 $can_access = 1;
             } else {
@@ -1193,9 +1178,9 @@
             $text_message = $tpl->getTemplateContents();
 
             // send email (use PEAR's classes)
-            $mail = new Mail_API;
+            $mail = new Mail_Helper;
             $mail->setTextBody($text_message);
-            $mail->setHeaders(Mail_API::getBaseThreadingHeaders($issue_id));
+            $mail->setHeaders(Mail_Helper::getBaseThreadingHeaders($issue_id));
             $setup = $mail->getSMTPSettings();
             $from = Notification::getFixedFromHeader($issue_id, $setup["from"], 'issue');
             $recipient = Mime_Helper::fixEncoding($recipient);
@@ -1229,7 +1214,7 @@
             for ($i = 0; $i < count($sup_ids); $i++) {
                 $senders = Support::getSender(array($sup_ids[$i]));
                 if (count($senders) > 0) {
-                    $sender_email = Mail_API::getEmailAddress($senders[0]);
+                    $sender_email = Mail_Helper::getEmailAddress($senders[0]);
                     $recipients[$sup_ids[$i]] = $senders[0];
                     $recipient_emails[] = $sender_email;
                 }
@@ -1241,16 +1226,16 @@
             $data = Issue::getDetails($issue_id);
             foreach ($recipients as $sup_id => $recipient) {
 
-                $recipient_usr_id = User::getUserIDByEmail(Mail_API::getEmailAddress($recipient));
+                $recipient_usr_id = User::getUserIDByEmail(Mail_Helper::getEmailAddress($recipient));
 
                 // open text template
-                $tpl = new Template_API;
+                $tpl = new Template_Helper();
                 $tpl->setTemplate('notifications/new_auto_created_issue.tpl.text');
                 $tpl->bulkAssign(array(
                     "data"        => $data,
-                    "sender_name" => Mail_API::getName($recipient),
+                    "sender_name" => Mail_Helper::getName($recipient),
                     "app_title"   => Misc::getToolCaption(),
-                    'recipient_name'    => Mail_API::getName($recipient),
+                    'recipient_name'    => Mail_Helper::getName($recipient),
                 ));
                 $email_details = Support::getEmailDetails(Email_Account::getAccountByEmail($sup_id), $sup_id);
                 $tpl->assign(array(
@@ -1271,11 +1256,11 @@
                 $text_message = $tpl->getTemplateContents();
 
                 // send email (use PEAR's classes)
-                $mail = new Mail_API;
+                $mail = new Mail_Helper;
                 $mail->setTextBody($text_message);
                 $setup = $mail->getSMTPSettings();
                 $from = Notification::getFixedFromHeader($issue_id, $setup["from"], 'issue');
-                $mail->setHeaders(Mail_API::getBaseThreadingHeaders($issue_id));
+                $mail->setHeaders(Mail_Helper::getBaseThreadingHeaders($issue_id));
                 $mail->send($from, $recipient, "[#$issue_id] Issue Created: " . $data['iss_summary'], 1, $issue_id, 'email_converted_to_issue');
             }
             Language::restore();
@@ -1334,14 +1319,14 @@
         }
         $stmt .= ") VALUES (
                     " . Misc::escapeInteger($project_id) . ",
-                    '" . Date_API::getCurrentDateGMT() . "',
+                    '" . Date_Helper::getCurrentDateGMT() . "',
                     'pending',
                     '" . Misc::escapeString($notice) . "'";
         if ($issue_id != false) {
             $stmt .= ",\n $issue_id";
         }
         $stmt .= ")";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -1364,7 +1349,7 @@
         $info = User::getDetails($usr_id);
         $info["projects"] = Project::getAssocList($usr_id, true, true);
         // open text template
-        $tpl = new Template_API;
+        $tpl = new Template_Helper();
         $tpl->setTemplate('notifications/updated_account.tpl.text');
         $tpl->bulkAssign(array(
             "app_title"    => Misc::getToolCaption(),
@@ -1377,7 +1362,7 @@
         $text_message = $tpl->getTemplateContents();
 
         // send email (use PEAR's classes)
-        $mail = new Mail_API;
+        $mail = new Mail_Helper;
         $mail->setTextBody($text_message);
         $setup = $mail->getSMTPSettings();
         $mail->send($setup["from"], $mail->getFormattedName($info["usr_full_name"], $info["usr_email"]), APP_SHORT_NAME . ": " . ev_gettext("User account information updated"));
@@ -1401,7 +1386,7 @@
         $info["usr_password"] = $password;
         $info["projects"] = Project::getAssocList($usr_id, true, true);
         // open text template
-        $tpl = new Template_API;
+        $tpl = new Template_Helper();
         $tpl->setTemplate('notifications/updated_password.tpl.text');
         $tpl->bulkAssign(array(
             "app_title"    => Misc::getToolCaption(),
@@ -1414,7 +1399,7 @@
         $text_message = $tpl->getTemplateContents();
 
         // send email (use PEAR's classes)
-        $mail = new Mail_API;
+        $mail = new Mail_Helper;
         $mail->setTextBody($text_message);
         $setup = $mail->getSMTPSettings();
         $mail->send($setup["from"], $mail->getFormattedName($info["usr_full_name"], $info["usr_email"]), APP_SHORT_NAME . ": " . ev_gettext("User account password changed"));
@@ -1438,7 +1423,7 @@
         $info["usr_password"] = $password;
         $info["projects"] = Project::getAssocList($usr_id, true, true);
         // open text template
-        $tpl = new Template_API;
+        $tpl = new Template_Helper();
         $tpl->setTemplate('notifications/new_user.tpl.text');
         $tpl->bulkAssign(array(
             "app_title"    => Misc::getToolCaption(),
@@ -1451,7 +1436,7 @@
         $text_message = $tpl->getTemplateContents();
 
         // send email (use PEAR's classes)
-        $mail = new Mail_API;
+        $mail = new Mail_Helper;
         $mail->setTextBody($text_message);
         $setup = $mail->getSMTPSettings();
         $mail->send($setup["from"], $mail->getFormattedName($info["usr_full_name"], $info["usr_email"]), APP_SHORT_NAME . ": " . ev_gettext("New User information"));
@@ -1477,7 +1462,7 @@
             // get issue details
             $issue = Notification::getIssueDetails($issue_id);
             // open text template
-            $tpl = new Template_API;
+            $tpl = new Template_Helper();
             $tpl->setTemplate('notifications/' . $type . '.tpl.text');
             $tpl->bulkAssign(array(
                 "app_title"    => Misc::getToolCaption(),
@@ -1486,7 +1471,7 @@
             ));
 
             for ($i = 0; $i < count($assignees); $i++) {
-                if (!Workflow::shouldEmailAddress($prj_id, Mail_API::getEmailAddress(User::getFromHeader($assignees[$i])))) {
+                if (!Workflow::shouldEmailAddress($prj_id, Mail_Helper::getEmailAddress(User::getFromHeader($assignees[$i])))) {
                     continue;
                 }
 
@@ -1495,9 +1480,9 @@
                 $text_message = $tpl->getTemplateContents();
 
                 // send email (use PEAR's classes)
-                $mail = new Mail_API;
+                $mail = new Mail_Helper;
                 $mail->setTextBody($text_message);
-                $mail->setHeaders(Mail_API::getBaseThreadingHeaders($issue_id));
+                $mail->setHeaders(Mail_Helper::getBaseThreadingHeaders($issue_id));
                 $mail->send(Notification::getFixedFromHeader($issue_id, '', 'issue'), User::getFromHeader($assignees[$i]), "[#$issue_id] $title: " . $issue['iss_summary'], TRUE, $issue_id, $type);
             }
             Language::restore();
@@ -1535,7 +1520,7 @@
         // get issue details
         $issue = Notification::getIssueDetails($issue_id);
         // open text template
-        $tpl = new Template_API;
+        $tpl = new Template_Helper();
         $tpl->setTemplate('notifications/assigned.tpl.text');
         $tpl->bulkAssign(array(
             "app_title"    => Misc::getToolCaption(),
@@ -1545,12 +1530,12 @@
 
         for ($i = 0; $i < count($emails); $i++) {
             $text_message = $tpl->getTemplateContents();
-            Language::set(User::getLang(User::getUserIDByEmail(Mail_API::getEmailAddress($emails[$i]))));
+            Language::set(User::getLang(User::getUserIDByEmail(Mail_Helper::getEmailAddress($emails[$i]))));
 
             // send email (use PEAR's classes)
-            $mail = new Mail_API;
+            $mail = new Mail_Helper;
             $mail->setTextBody($text_message);
-            $mail->setHeaders(Mail_API::getBaseThreadingHeaders($issue_id));
+            $mail->setHeaders(Mail_Helper::getBaseThreadingHeaders($issue_id));
             $mail->send(Notification::getFixedFromHeader($issue_id, '', 'issue'), $emails[$i], "[#$issue_id] New Assignment: " . $issue['iss_summary'], TRUE, $issue_id, 'assignment');
         }
         Language::restore();
@@ -1569,7 +1554,7 @@
         $info = User::getDetails($usr_id);
         $info["projects"] = Project::getAssocList($usr_id, true, true);
         // open text template
-        $tpl = new Template_API;
+        $tpl = new Template_Helper();
         $tpl->setTemplate('notifications/account_details.tpl.text');
         $tpl->bulkAssign(array(
             "app_title"    => Misc::getToolCaption(),
@@ -1580,7 +1565,7 @@
         $text_message = $tpl->getTemplateContents();
 
         // send email (use PEAR's classes)
-        $mail = new Mail_API;
+        $mail = new Mail_Helper;
         $mail->setTextBody($text_message);
         $setup = $mail->getSMTPSettings();
         $mail->send($setup["from"], $mail->getFormattedName($info["usr_full_name"], $info["usr_email"]), APP_SHORT_NAME . ": " . ev_gettext("Your User Account Details"));
@@ -1637,7 +1622,7 @@
             $stmt .= " AND\nsbt_sub_id = sub_id AND
                       sbt_type = '" . Misc::escapeString($type) . "'";
         }
-        $users = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $users = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($users)) {
             Error_Handler::logError(array($users->getMessage(), $users->getDebugInfo()), __FILE__, __LINE__);
             return array();
@@ -1676,7 +1661,7 @@
             if ($type != false) {
                 $stmt .= " AND\nsbt_type = '" . Misc::escapeString($type) . "'";
             }
-            $emails = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+            $emails = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
             if (PEAR::isError($emails)) {
                 Error_Handler::logError(array($emails->getMessage(), $emails->getDebugInfo()), __FILE__, __LINE__);
                 return array();
@@ -1716,7 +1701,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "subscription
                  WHERE
                     sub_id=" . Misc::escapeInteger($sub_id);
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getRow($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1747,7 +1732,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "subscription_type
                  WHERE
                     sbt_sub_id=" . Misc::escapeInteger($sub_id);
-        $res = $GLOBALS["db_api"]->dbh->getAssoc($stmt);
+        $res = Db_Helper::getInstance()->getAssoc($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1775,7 +1760,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "subscription
                  WHERE
                     sub_iss_id=" . Misc::escapeInteger($issue_id);
-        $res = $GLOBALS["db_api"]->dbh->getAll($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getAll($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return "";
@@ -1810,7 +1795,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "subscription
                  WHERE
                     sub_iss_id IN ($items)";
-        $res = $GLOBALS["db_api"]->dbh->getCol($stmt);
+        $res = Db_Helper::getInstance()->getCol($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return false;
@@ -1838,7 +1823,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "subscription
                  WHERE
                     sub_id IN (" . implode(", ", $items) . ")";
-        $issue_id = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $issue_id = Db_Helper::getInstance()->getOne($stmt);
 
         for ($i = 0; $i < count($items); $i++) {
             $sub_id = $items[$i];
@@ -1847,12 +1832,12 @@
                         " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "subscription
                      WHERE
                         sub_id=$sub_id";
-            $GLOBALS["db_api"]->dbh->query($stmt);
+            Db_Helper::getInstance()->query($stmt);
             $stmt = "DELETE FROM
                         " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "subscription_type
                      WHERE
                         sbt_sub_id=$sub_id";
-            $GLOBALS["db_api"]->dbh->query($stmt);
+            Db_Helper::getInstance()->query($stmt);
             // need to save a history entry for this
             History::add($issue_id, Auth::getUserID(), History::getTypeID('notification_removed'),
                             ev_gettext('Notification list entry (%1$s) removed by %2$s', $subscriber, User::getFullName(Auth::getUserID())));
@@ -1879,7 +1864,7 @@
                     " . APP_DEFAULT_DB . "." . APP_TABLE_PREFIX . "subscription
                  WHERE
                     sub_id=" . Misc::escapeInteger($sub_id);
-        $res = $GLOBALS["db_api"]->dbh->getRow($stmt, DB_FETCHMODE_ASSOC);
+        $res = Db_Helper::getInstance()->getRow($stmt, DB_FETCHMODE_ASSOC);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return '';
@@ -1982,7 +1967,7 @@
                  WHERE
                     sub_iss_id=$issue_id AND
                     sub_usr_id=$subscriber_usr_id";
-        $total = $GLOBALS["db_api"]->dbh->getOne($stmt);
+        $total = Db_Helper::getInstance()->getOne($stmt);
         if ($total > 0) {
             return -1;
         }
@@ -1997,11 +1982,11 @@
                  ) VALUES (
                     $issue_id,
                     $subscriber_usr_id,
-                    '" . Date_API::getCurrentDateGMT() . "',
+                    '" . Date_Helper::getCurrentDateGMT() . "',
                     'issue',
                     ''
                  )";
-        $res = $GLOBALS["db_api"]->dbh->query($stmt);
+        $res = Db_Helper::getInstance()->query($stmt);
         if (PEAR::isError($res)) {
             Error_Handler::logError(array($res->getMessage(), $res->getDebugInfo()), __FILE__, __LINE__);
             return -1;
@@ -2035,7 +2020,7 @@
      */
     function subscribeEmail($usr_id, $issue_id, $form_email, $actions)
     {
-        $form_email = Mail_API::getEmailAddress($form_email);
+        $form_email = Mail_Helper::getEmailAddress($form_email);
         if (!is_string($form_email)) {
             return -1;
         }
@@ -2068,7 +2053,7 @@
                      WHERE
                         sub_iss_id=$issue_id AND
                         sub_email='$email'";
-            $total = $GLOBALS["db_api"]->dbh->getOne($stmt);
+            $total = Db_Helper::getInstance()->getOne($stmt);
             if ($total > 0) {
                 return -1;
             }
